/*
 * motors.h
 *
 *  Created on: 02.02.2014
 *      Author: AndreR
 */

#ifndef MOTORS_H_
#define MOTORS_H_

#include "ch.h"
#include "intercom_constants.h"

typedef void(*MotorsUpdateCallback)(uint8_t);

typedef struct _Motors
{
	struct _mot
	{
		MotorSetpoint set;
		MotorFeedback cur;

		GPIO_TypeDef* pFaultPort;
		uint32_t faultPin;
		uint16_t faultCounter;
		uint8_t fault;
	} mot[4];

	MotorsUpdateCallback updateCb;

	uint32_t lastMotRx[2];

	uint8_t ctrlMode;
} Motors;

extern Motors motors;

void MotorsInit();
void MotorsTask(void* params);

#endif /* MOTORS_H_ */
